#!/usr/bin/env python
"""
Module to read in a list of image file names then calculate the perceptual hash for each.
The files are those generated by running the dl tools.
"""
import imagehash
from PIL import Image
import re, sys, os
from mysql.connector import connect, Error
import concurrent.futures
import argparse
import logging

def dbconn(db):
    return connect(
            host="localhost",
            user=os.environ["PPDBUSER"],
            password=os.environ["PPDBPW"],
            database=db
        )

def save(h,sha1,db,iid=None):
    """
    updates images table with the phash
    """
    try:
        with dbconn(db) as connection:
            with connection.cursor() as cursor:
                if iid is None:
                    querystr = "update images set phash='{0}' where sha1='{1}'".format(h, sha1)
                else:
                    querystr = "update images set phash='{0}' where iid={1}".format(h,iid)
                cursor.execute(querystr)
                connection.commit()
    except Error as e:
        logging.error("failed to save {0} {1} {2}: {3}".format(h,sha1,iid,e))

def hash_and_save(p,db=None,iid=None):
    """
    takes path p as input, computes image hash and saves
    it to database connection provided
    """
    h = imagehash.phash(Image.open(p))
    logging.info("{0} {1} {2}".format(iid,h,p))
    # get the sha1 from the file name
    m = re.match(r".*/(\w+)-\d+\.\w+$", p)
    if m is not None:
        if db is not None:
            save(h, m.group(1), db, iid)

def main(db, listfile):
    """
    this takes a db name and 
    list of unique image files from the "images" directory as input
    these files are all named .../<sha1>-<size>.<ext>
    it concurrently tries to generate the perceptual hash for each 
    image and saves that, if successful, to the images  table's phash field
    PPDBUSER and PPDBPW environment variables must be set to connect to db
    """
    try:
        with concurrent.futures.ThreadPoolExecutor() as executor:
            with open(listfile, "r") as listh:
                for l in listh:
                    m = re.match(r"\|\s+(\d+)\s+\|\s+(\S*\w)\s+\|", l)
                    if m is not None:
                        p = m.group(2).strip()
                        iid = int(m.group(1))
                    else:
                        p = l.strip()
                        iid = None
                    if not os.path.isfile(p):
                        continue
                    executor.submit(hash_and_save, p=p, db=db, iid=iid)

    except Error as e:
        logging.error("db {0} list {1}:{2}".format(db,listfile,e))

if __name__ == "__main__":
    parser = argparse.ArgumentParser(
            description="""concurrently generates perceptual hashes 
            for a list of image files and 
            attempts to save them to a database 
            table keyed by the sha1 of the image.""")
    parser.add_argument("db",
            help="""database name to connect to, 
            should have an images table with a phash field""")
    parser.add_argument("listfile", 
            help="""list of paths with sha1s in the file name
            in the form: <sha1>-<file size>.<ext>""")
    parser.add_argument("--log",help="path to log file")
    args = parser.parse_args()
    if args.log is not None:
        logging.basicConfig(filename=args.log, level=logging.DEBUG)
    main(args.db, args.listfile)

